class AccentorTTSModel(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  stress_token : str
  yo_token : str
  vowels : str
  exceptions : Dict[str, int]
  stress_trs : float
  yo_trs : float
  grapheme2idx : Dict[str, int]
  symbol_to_id : Dict[str, int]
  sos_token : str
  eos_token : str
  tts_model : __torch__.silero_vocoder.jit_model.___torch_mangle_75.MultiTTSModel
  accentor : __torch__.models.accentor.AccentorClean
  def forward(self: __torch__.silero_vocoder.jit_model.___torch_mangle_76.AccentorTTSModel,
    sentences: List[str],
    clean_sentences: List[str],
    break_lens: List[Optional[int]],
    prosody_rates: List[float],
    prosody_pitches: List[float],
    speaker_ids: Tensor,
    sr: int=48000,
    device: str="cpu",
    put_yo: bool=True,
    put_accent: bool=True,
    gt_durs: Optional[Tensor]=None,
    gt_pitch: Optional[Tensor]=None) -> Tuple[Tensor, Tensor]:
    if put_accent:
      _0 = (self).preprocess_batch_accentor(clean_sentences, )
      graphemes, g_lengths, sentence_ids, = _0
      _1 = (self).get_accentor_preds(graphemes, g_lengths, )
      stress_probs, stress_preds, yo_probs, yo_preds, = _1
      acc_sentences0 = (self).postprocess_batch_accentor(sentences, stress_probs, stress_preds, yo_probs, yo_preds, sentence_ids, put_yo, )
      acc_sentences = acc_sentences0
    else:
      acc_sentences = sentences
    _2 = (self).merge_batch_model(acc_sentences, break_lens, prosody_rates, prosody_pitches, )
    sequence, symb_durs, durs_rate, pitch_coefs, = _2
    tts_model = self.tts_model
    _3 = torch.to(sequence, torch.device(device))
    _4 = torch.to(speaker_ids, torch.device(device))
    _5 = torch.to(durs_rate, torch.device(device))
    _6 = torch.to(pitch_coefs, torch.device(device))
    _7 = (tts_model).forward(_3, _4, sr, symb_durs, _5, _6, gt_durs, gt_pitch, device, )
    audio, audio_lengths, = _7
    return (audio, audio_lengths)
  def preprocess_batch_accentor(self: __torch__.silero_vocoder.jit_model.___torch_mangle_76.AccentorTTSModel,
    sentences: List[str]) -> Tuple[Tensor, Tensor, List[int]]:
    graphemes = annotate(List[List[int]], [])
    sentence_ids = annotate(List[int], [])
    non_empty_words = 0
    for _8 in range(torch.len(sentences)):
      sentence = sentences[_8]
      words = torch.split(sentence)
      non_empty_words0 = non_empty_words
      for _9 in range(torch.len(words)):
        word = words[_9]
        if torch.ne(word, ""):
          _10 = torch.append(graphemes, (self)._graphemes2ids(word, ))
          non_empty_words2 = torch.add(non_empty_words0, 1)
          non_empty_words1 = non_empty_words2
        else:
          non_empty_words1 = non_empty_words0
        non_empty_words0 = non_empty_words1
      _11 = torch.append(sentence_ids, non_empty_words0)
      non_empty_words = non_empty_words0
    graphemes0, g_lengths, = (self)._collate_fn(graphemes, )
    _12 = (graphemes0, g_lengths, sentence_ids)
    return _12
  def _graphemes2ids(self: __torch__.silero_vocoder.jit_model.___torch_mangle_76.AccentorTTSModel,
    graphemes: str) -> List[int]:
    graphemes_ids = annotate(List[int], [])
    for _13 in range(torch.len(graphemes)):
      g = graphemes[_13]
      grapheme2idx = self.grapheme2idx
      _14 = torch.append(graphemes_ids, grapheme2idx[g])
    return graphemes_ids
  def _collate_fn(self: __torch__.silero_vocoder.jit_model.___torch_mangle_76.AccentorTTSModel,
    grapheme_list: List[List[int]]) -> Tuple[Tensor, Tensor]:
    grapheme2idx = self.grapheme2idx
    grapheme_pad = grapheme2idx["_"]
    graphemes_lengths = annotate(List[int], [])
    for _15 in range(torch.len(grapheme_list)):
      x = grapheme_list[_15]
      _16 = torch.append(graphemes_lengths, torch.len(x))
    max_word_length = ops.prim.max(graphemes_lengths)
    batch_size = torch.len(grapheme_list)
    _17 = torch.zeros([batch_size, max_word_length], dtype=4)
    graphemes_inputs = torch.add(_17, grapheme_pad)
    g_lengths = torch.zeros([batch_size], dtype=4)
    for x0 in range(batch_size):
      graphemes = grapheme_list[x0]
      graphemes1 = torch.to(torch.tensor(graphemes), 4)
      graphemes_seq_length = torch.size(graphemes1, 0)
      _18 = torch.select(graphemes_inputs, 0, x0)
      _19 = torch.narrow(_18, 0, 0, graphemes_seq_length)
      _20 = torch.copy_(_19, graphemes1)
      _21 = torch.select(g_lengths, 0, x0)
      _22 = torch.tensor(graphemes_seq_length, dtype=ops.prim.dtype(_21), device=ops.prim.device(_21))
      _23 = torch.copy_(_21, _22)
    return (graphemes_inputs, g_lengths)
  def get_accentor_preds(self: __torch__.silero_vocoder.jit_model.___torch_mangle_76.AccentorTTSModel,
    graphemes: Tensor,
    g_lengths: Tensor) -> Tuple[Tensor, Tensor, Tensor, Tensor]:
    accentor = self.accentor
    _24 = (accentor).forward(graphemes, g_lengths, )
    stress_logits, yo_logits, = _24
    stress_probs = torch.softmax(stress_logits, 1)
    stress_preds = torch.argmax(stress_probs, 1)
    yo_probs = torch.softmax(yo_logits, 1)
    yo_preds = torch.argmax(yo_probs, 1)
    _25 = (stress_probs, stress_preds, yo_probs, yo_preds)
    return _25
  def postprocess_batch_accentor(self: __torch__.silero_vocoder.jit_model.___torch_mangle_76.AccentorTTSModel,
    sentences: List[str],
    stress_probs: Tensor,
    stress_preds: Tensor,
    yo_probs: Tensor,
    yo_preds: Tensor,
    sentence_ids: List[int],
    put_yo: bool) -> List[str]:
    acc_sentences = annotate(List[str], [])
    _26 = [torch.len(sentences), torch.len(sentence_ids)]
    prev_word_idx = 0
    for _27 in range(ops.prim.min(_26)):
      sentence = sentences[_27]
      cur_word_idx = sentence_ids[_27]
      _28 = torch.slice(stress_probs, 0, prev_word_idx, cur_word_idx)
      _29 = torch.slice(stress_preds, 0, prev_word_idx, cur_word_idx)
      _30 = torch.slice(yo_probs, 0, prev_word_idx, cur_word_idx)
      _31 = torch.slice(yo_preds, 0, prev_word_idx, cur_word_idx)
      acc_sentence = (self).postprocess_accentor(sentence, _28, _29, _30, _31, put_yo, )
      _32 = torch.append(acc_sentences, acc_sentence)
      prev_word_idx = cur_word_idx
    return acc_sentences
  def postprocess_accentor(self: __torch__.silero_vocoder.jit_model.___torch_mangle_76.AccentorTTSModel,
    sentence: str,
    stress_probs: Tensor,
    stress_preds: Tensor,
    yo_probs: Tensor,
    yo_preds: Tensor,
    put_yo_main: bool) -> str:
    _33 = uninitialized(int)
    _34 = uninitialized(bool)
    new_sentence = annotate(List[str], [])
    words = torch.split(sentence)
    _35 = [9223372036854775807, torch.len(words)]
    _36 = ops.prim.min(_35)
    _37 = 0
    word_idx = 0
    _38 = torch.gt(_36, 0)
    while _38:
      word = words[_37]
      exceptions = self.exceptions
      _39 = torch.__contains__(exceptions, word)
      if _39:
        exceptions0 = self.exceptions
        stress_pos = exceptions0[word]
        _45 = torch.slice(word, None, stress_pos)
        stress_token = self.stress_token
        word0 = torch.add(torch.add(_45, stress_token), torch.slice(word, stress_pos))
        _46 = torch.append(new_sentence, word0)
        _40, _41, _42, _43, _44 = True, True, word_idx, _34, _33
      else:
        if torch.eq(word, ""):
          _47, _48, _49, _50, _51 = True, True, torch.sub(word_idx, 1), _34, _33
        else:
          punct_only = annotate(List[bool], [])
          for _52 in range(torch.len(word)):
            s = word[_52]
            _53 = torch.find(CONSTANTS.c0, s, 0, 12)
            if torch.ne(_53, -1):
              _54 = torch.append(punct_only, True)
            else:
              _55 = torch.append(punct_only, False)
          if torch.all(punct_only):
            _61 = torch.append(new_sentence, word)
            _56, _57, _58, _59, _60 = True, True, word_idx, _34, _33
          else:
            stress_token0 = self.stress_token
            _62 = torch.find(word, stress_token0, 0, torch.len(word))
            have_stress = torch.ne(_62, -1)
            yo_token = self.yo_token
            _63 = torch.find(word, yo_token, 0, torch.len(word))
            have_yo = torch.ne(_63, -1)
            if torch.eq(have_stress, True):
              _64 = torch.eq(have_yo, True)
            else:
              _64 = False
            if _64:
              _70 = torch.append(new_sentence, word)
              _65, _66, _67, _68, _69 = True, True, word_idx, _34, _33
            else:
              stressed_vowel_idx = torch.select(stress_preds, 0, word_idx)
              _71 = torch.select(stress_probs, 0, word_idx)
              _72 = annotate(List[Optional[Tensor]], [stressed_vowel_idx])
              _73 = torch.index(_71, _72)
              stress_trs = self.stress_trs
              put_stress = bool(torch.gt(_73, stress_trs))
              yo_vowel_idx = torch.select(yo_preds, 0, word_idx)
              if put_yo_main:
                _74 = torch.select(yo_probs, 0, word_idx)
                _75 = annotate(List[Optional[Tensor]], [yo_vowel_idx])
                _76 = torch.index(_74, _75)
                yo_trs = self.yo_trs
                _77 = bool(torch.gt(_76, yo_trs))
                put_yo = _77
              else:
                put_yo = False
              _78 = torch.eq(stressed_vowel_idx, 0)
              if bool(_78):
                put_stress0, stressed_vowel_idx0 = False, torch.tensor(-10)
              else:
                stressed_vowel_idx1 = torch.sub_(stressed_vowel_idx, 1)
                put_stress0, stressed_vowel_idx0 = put_stress, stressed_vowel_idx1
              if put_stress0:
                put_yo0 = put_yo
              else:
                put_yo0 = False
              _79 = (self)._get_positions(word, stressed_vowel_idx0, yo_vowel_idx, )
              stress_pos0, yo_pos, cur_vowel_idx, first_vowel_pos, = _79
              if torch.__not__(have_yo):
                _81 = torch.eq(stress_pos0, yo_pos)
                _80 = _81
              else:
                _80 = False
              if _80:
                _82 = put_yo0
              else:
                _82 = False
              if _82:
                _83 = torch.gt(yo_pos, -1)
              else:
                _83 = False
              if _83:
                _84 = torch.eq(word[yo_pos], "e")
                if _84:
                  _85 = torch.slice(word, None, yo_pos)
                  yo_token0 = self.yo_token
                  _86 = torch.add(_85, yo_token0)
                  _87 = torch.slice(word, torch.add(yo_pos, 1))
                  word2 = torch.add(_86, _87)
                else:
                  word2 = word
                word1 = word2
              else:
                word1 = word
              _88 = torch.eq(cur_vowel_idx, 0)
              if _88:
                put_stress1, stress_pos1 = True, first_vowel_pos
              else:
                put_stress1, stress_pos1 = put_stress0, stress_pos0
              _89 = torch.__not__(have_stress)
              if _89:
                _90 = put_stress1
              else:
                _90 = False
              if _90:
                _92 = torch.ne(cur_vowel_idx, -1)
                _91 = _92
              else:
                _91 = False
              if _91:
                _94 = torch.gt(stress_pos1, -1)
                _93 = _94
              else:
                _93 = False
              if _93:
                _95 = torch.slice(word1, None, stress_pos1)
                stress_token1 = self.stress_token
                _96 = torch.add(_95, stress_token1)
                _97 = torch.slice(word1, stress_pos1)
                word3 = torch.add(_96, _97)
              else:
                word3 = word1
              _98 = torch.append(new_sentence, word3)
              _65, _66, _67, _68, _69 = False, _34, _33, True, torch.add(word_idx, 1)
            _56, _57, _58, _59, _60 = _65, _66, _67, _68, _69
          _47, _48, _49, _50, _51 = _56, _57, _58, _59, _60
        _40, _41, _42, _43, _44 = _47, _48, _49, _50, _51
      if _40:
        _99, _100 = _41, _42
      else:
        _99, _100 = _43, _44
      _101 = torch.add(_37, 1)
      _102 = torch.__and__(torch.lt(_101, _36), _99)
      _38, _37, word_idx = _102, _101, _100
    return torch.join(" ", new_sentence)
  def _get_positions(self: __torch__.silero_vocoder.jit_model.___torch_mangle_76.AccentorTTSModel,
    word: str,
    stressed_vowel_idx: Tensor,
    yo_vowel_idx: Tensor) -> Tuple[int, int, int, int]:
    _103 = [9223372036854775807, torch.len(word)]
    stress_pos = -1
    yo_pos = -1
    cur_vowel_idx = -1
    first_vowel_pos = -1
    for i in range(ops.prim.min(_103)):
      c = word[i]
      vowels = self.vowels
      _104 = torch.find(vowels, c, 0, torch.len(vowels))
      if torch.ne(_104, -1):
        cur_vowel_idx1 = torch.add(cur_vowel_idx, 1)
        if torch.eq(first_vowel_pos, -1):
          first_vowel_pos1 = i
        else:
          first_vowel_pos1 = first_vowel_pos
        cur_vowel_idx0, first_vowel_pos0 = cur_vowel_idx1, first_vowel_pos1
      else:
        cur_vowel_idx0, first_vowel_pos0 = cur_vowel_idx, first_vowel_pos
      _105 = torch.eq(stressed_vowel_idx, cur_vowel_idx0)
      if bool(_105):
        _106 = torch.eq(stress_pos, -1)
      else:
        _106 = False
      if _106:
        stress_pos2 = i
      else:
        stress_pos2 = stress_pos
      _107 = torch.eq(torch.sub(yo_vowel_idx, 1), cur_vowel_idx0)
      if bool(_107):
        _108 = torch.eq(yo_pos, -1)
      else:
        _108 = False
      if _108:
        yo_pos0 = i
      else:
        yo_pos0 = yo_pos
      stress_pos, yo_pos, cur_vowel_idx, first_vowel_pos = stress_pos2, yo_pos0, cur_vowel_idx0, first_vowel_pos0
    _109 = (stress_pos, yo_pos, cur_vowel_idx, first_vowel_pos)
    return _109
  def merge_batch_model(self: __torch__.silero_vocoder.jit_model.___torch_mangle_76.AccentorTTSModel,
    texts: List[str],
    break_lens: List[Optional[int]],
    prosody_rates: List[float],
    prosody_pitches: List[float]) -> Tuple[Tensor, Dict[int, int], Tensor, Tensor]:
    symb_durs = annotate(Dict[int, int], {})
    final_rates = annotate(List[float], [])
    final_pitches = annotate(List[float], [])
    _110 = [9223372036854775807, torch.len(break_lens)]
    text_len = -1
    for i in range(ops.prim.min(_110)):
      break_len = break_lens[i]
      _111 = torch.sub(torch.len(break_lens), 1)
      if torch.lt(i, _111):
        cur_text_len0 = torch.add(torch.len(texts[i]), 1)
        cur_text_len = cur_text_len0
      else:
        cur_text_len1 = torch.add(torch.len(texts[i]), 2)
        cur_text_len = cur_text_len1
      text_len0 = torch.add(text_len, cur_text_len)
      if torch.__isnot__(break_len, None):
        break_len0 = unchecked_cast(int, break_len)
        _112 = torch.sub(torch.len(break_lens), 1)
        if torch.lt(i, _112):
          torch._set_item(symb_durs, text_len0, break_len0)
        else:
          torch._set_item(symb_durs, torch.sub(text_len0, 1), break_len0)
      else:
        pass
      rate = prosody_rates[i]
      torch.extend(final_rates, torch.mul([rate], cur_text_len))
      pitch = prosody_pitches[i]
      torch.extend(final_pitches, torch.mul([pitch], cur_text_len))
      text_len = text_len0
    full_text = torch.join(" ", texts)
    _113 = (self).preprocess_tacotron(full_text, )
    text_tensor = torch.unsqueeze(_113, 0)
    rate_tensor = torch.unsqueeze(torch.tensor(final_rates), 0)
    pitch_tensor = torch.unsqueeze(torch.tensor(final_pitches), 0)
    _114 = (text_tensor, symb_durs, rate_tensor, pitch_tensor)
    return _114
  def preprocess_tacotron(self: __torch__.silero_vocoder.jit_model.___torch_mangle_76.AccentorTTSModel,
    text: str) -> Tensor:
    sos_token = self.sos_token
    _115 = torch.add(sos_token, text)
    eos_token = self.eos_token
    text0 = torch.add(_115, eos_token)
    text_ohe = annotate(List[int], [])
    for _116 in range(torch.len(text0)):
      s = text0[_116]
      symbol_to_id = self.symbol_to_id
      _117 = torch.append(text_ohe, symbol_to_id[s])
    return torch.to(torch.tensor(text_ohe), 4)
