class LSTM(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  mode : str
  input_size : int
  hidden_size : int
  num_layers : int
  bias : bool
  batch_first : bool
  dropout : float
  bidirectional : bool
  dtype : int
  version : int
  _all_weight_values : __torch__.torch.nn.modules.container.___torch_mangle_69.ModuleList
  def forward_packed(self: __torch__.torch.nn.quantized.dynamic.modules.rnn.LSTM,
    input: __torch__.torch.nn.utils.rnn.PackedSequence,
    hx: Optional[Tuple[Tensor, Tensor]]=None) -> Tuple[__torch__.torch.nn.utils.rnn.PackedSequence, Tuple[Tensor, Tensor]]:
    input_, batch_sizes, sorted_indices, unsorted_indices, = input
    max_batch_size = torch.select(batch_sizes, 0, 0)
    max_batch_size0 = int(max_batch_size)
    _0 = (self).forward_impl(input_, hx, batch_sizes, max_batch_size0, sorted_indices, )
    output_, hidden, = _0
    output = __torch__.torch.nn.utils.rnn.PackedSequence(output_, batch_sizes, sorted_indices, unsorted_indices)
    _1 = (self).permute_hidden(hidden, unsorted_indices, )
    return (output, _1)
  def forward_tensor(self: __torch__.torch.nn.quantized.dynamic.modules.rnn.LSTM,
    input: Tensor,
    hx: Optional[Tuple[Tensor, Tensor]]=None) -> Tuple[Tensor, Tuple[Tensor, Tensor]]:
    batch_first = self.batch_first
    if batch_first:
      max_batch_size = torch.size(input, 0)
    else:
      max_batch_size = torch.size(input, 1)
    _2 = (self).forward_impl(input, hx, None, max_batch_size, None, )
    output, hidden, = _2
    _3 = (self).permute_hidden(hidden, None, )
    return (output, _3)
  def forward_impl(self: __torch__.torch.nn.quantized.dynamic.modules.rnn.LSTM,
    input: Tensor,
    hx: Optional[Tuple[Tensor, Tensor]],
    batch_sizes: Optional[Tensor],
    max_batch_size: int,
    sorted_indices: Optional[Tensor]) -> Tuple[Tensor, Tuple[Tensor, Tensor]]:
    if torch.__is__(hx, None):
      bidirectional = self.bidirectional
      if bidirectional:
        num_directions = 2
      else:
        num_directions = 1
      num_layers = self.num_layers
      _4 = torch.mul(num_layers, num_directions)
      hidden_size = self.hidden_size
      _5 = ops.prim.dtype(input)
      _6 = ops.prim.device(input)
      zeros = torch.zeros([_4, max_batch_size, hidden_size], dtype=_5, layout=None, device=_6)
      hx0 = (zeros, zeros)
    else:
      hx1 = unchecked_cast(Tuple[Tensor, Tensor], hx)
      hx2 = (self).permute_hidden(hx1, sorted_indices, )
      hx0 = hx2
    _7 = (self).check_forward_args(input, hx0, batch_sizes, )
    _all_params = annotate(List[__torch__.torch.classes.rnn.CellParamsBase], [])
    _all_weight_values = self._all_weight_values
    _0 = getattr(_all_weight_values, "0")
    _1 = getattr(_all_weight_values, "1")
    _2 = getattr(_all_weight_values, "2")
    _3 = getattr(_all_weight_values, "3")
    _40 = getattr(_all_weight_values, "4")
    _50 = getattr(_all_weight_values, "5")
    _60 = getattr(_all_weight_values, "6")
    _70 = getattr(_all_weight_values, "7")
    param = _0.param
    _8 = torch.append(_all_params, param)
    param0 = _1.param
    _9 = torch.append(_all_params, param0)
    param1 = _2.param
    _10 = torch.append(_all_params, param1)
    param2 = _3.param
    _11 = torch.append(_all_params, param2)
    param3 = _40.param
    _12 = torch.append(_all_params, param3)
    param4 = _50.param
    _13 = torch.append(_all_params, param4)
    param5 = _60.param
    _14 = torch.append(_all_params, param5)
    param6 = _70.param
    _15 = torch.append(_all_params, param6)
    if torch.__is__(batch_sizes, None):
      bias = self.bias
      num_layers0 = self.num_layers
      dropout = self.dropout
      training = self.training
      bidirectional0 = self.bidirectional
      batch_first = self.batch_first
      dtype = self.dtype
      _16, _17, = hx0
      _18, _19, _20 = torch.quantized_lstm(input, [_16, _17], _all_params, bias, num_layers0, dropout, training, bidirectional0, batch_first, dtype=dtype, use_dynamic=True)
      result = (_18, _19, _20)
    else:
      batch_sizes0 = unchecked_cast(Tensor, batch_sizes)
      bias0 = self.bias
      num_layers1 = self.num_layers
      dropout0 = self.dropout
      training0 = self.training
      bidirectional1 = self.bidirectional
      dtype0 = self.dtype
      _21, _22, = hx0
      _23, _24, _25 = torch.quantized_lstm(input, batch_sizes0, [_21, _22], _all_params, bias0, num_layers1, dropout0, training0, bidirectional1, dtype=dtype0, use_dynamic=True)
      result = (_23, _24, _25)
    output = (result)[0]
    hidden = ((result)[1], (result)[2])
    return (output, hidden)
  def permute_hidden(self: __torch__.torch.nn.quantized.dynamic.modules.rnn.LSTM,
    hx: Tuple[Tensor, Tensor],
    permutation: Optional[Tensor]) -> Tuple[Tensor, Tensor]:
    _26 = __torch__.torch.nn.quantized.dynamic.modules.rnn.apply_permutation
    if torch.__is__(permutation, None):
      _27 = hx
    else:
      permutation0 = unchecked_cast(Tensor, permutation)
      _28 = (_26((hx)[0], permutation0, 1, ), _26((hx)[1], permutation0, 1, ))
      _27 = _28
    return _27
  def check_forward_args(self: __torch__.torch.nn.quantized.dynamic.modules.rnn.LSTM,
    input: Tensor,
    hidden: Tuple[Tensor, Tensor],
    batch_sizes: Optional[Tensor]) -> NoneType:
    _29 = "Expected hidden[0] size {}, got {}"
    _30 = "Expected hidden[1] size {}, got {}"
    _31 = (self).check_input(input, batch_sizes, )
    expected_hidden_size = (self).get_expected_hidden_size(input, batch_sizes, )
    _32 = (self).check_hidden_size((hidden)[0], expected_hidden_size, _29, )
    _33 = (self).check_hidden_size((hidden)[1], expected_hidden_size, _30, )
    return None
  def check_input(self: __torch__.torch.nn.quantized.dynamic.modules.rnn.LSTM,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> NoneType:
    _34 = "input must have {} dimensions, got {}"
    _35 = "input.size(-1) must be equal to input_size. Expected {}, got {}"
    if torch.__isnot__(batch_sizes, None):
      expected_input_dim = 2
    else:
      expected_input_dim = 3
    _36 = torch.ne(torch.dim(input), expected_input_dim)
    if _36:
      _37 = torch.format(_34, expected_input_dim, torch.dim(input))
      ops.prim.RaiseException(_37)
    else:
      pass
    input_size = self.input_size
    _38 = torch.ne(input_size, torch.size(input, -1))
    if _38:
      input_size0 = self.input_size
      _39 = torch.format(_35, input_size0, torch.size(input, -1))
      ops.prim.RaiseException(_39)
    else:
      pass
    return None
  def get_expected_hidden_size(self: __torch__.torch.nn.quantized.dynamic.modules.rnn.LSTM,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> Tuple[int, int, int]:
    if torch.__isnot__(batch_sizes, None):
      batch_sizes1 = unchecked_cast(Tensor, batch_sizes)
      mini_batch0 = int(torch.select(batch_sizes1, 0, 0))
      mini_batch = mini_batch0
    else:
      batch_first = self.batch_first
      if batch_first:
        mini_batch1 = torch.size(input, 0)
      else:
        mini_batch1 = torch.size(input, 1)
      mini_batch = mini_batch1
    bidirectional = self.bidirectional
    if bidirectional:
      num_directions = 2
    else:
      num_directions = 1
    num_layers = self.num_layers
    _40 = torch.mul(num_layers, num_directions)
    hidden_size = self.hidden_size
    return (_40, mini_batch, hidden_size)
  def check_hidden_size(self: __torch__.torch.nn.quantized.dynamic.modules.rnn.LSTM,
    hx: Tensor,
    expected_hidden_size: Tuple[int, int, int],
    msg: str="Expected hidden size {}, got {}") -> NoneType:
    _41 = torch.size(hx)
    _42, _43, _44, = expected_hidden_size
    if torch.ne(_41, [_42, _43, _44]):
      _45 = torch.format(msg, expected_hidden_size, torch.list(torch.size(hx)))
      ops.prim.RaiseException(_45)
    else:
      pass
    return None
class PackedParameter(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  param : __torch__.torch.classes.rnn.CellParamsBase
def apply_permutation(tensor: Tensor,
    permutation: Tensor,
    dim: int=1) -> Tensor:
  _46 = torch.index_select(tensor, dim, permutation)
  return _46
